using System;

namespace MWDataGrabber
{
    class Program
    {
        private static void ListKeyTargets( EsmFile file )
        {
            foreach ( Record r in file.Records )
            {
                Records.Cell cell = r as Records.Cell;
                if ( cell != null )
                {
                    foreach ( SubRecords.CellObject obj in cell.Objects )
                    {
						if ( !string.IsNullOrEmpty( obj.KeyName ) )
						{
							Record master = file.Records.Find( delegate( Record srch )
							{
								return ( srch.Id == obj.Name );
							} );

							Record key = file.Records.Find( delegate( Record srch )
							{
								return ( srch.Id == obj.KeyName );
							} );

							Console.WriteLine( "{6}	{0} ({4}) - locked ({1}) {5} [{2}] in {3}", obj.KeyName, obj.LockLevel, ( master.Type == RecordType.Cell ? master.Id : master.Name ), cell.Id, key.Name, master.Type, key.Namespace );
						}
                    }
                }
            }
        }

        static void Main( string[] args )
        {
			EsmFile TRdata = new EsmFile( @"C:\Downloads\Code\Data\TR_Data.esm", "TRData" );
            TRdata.Load();
			EsmFile TR1 = new EsmFile( @"C:\Downloads\Code\Data\TR_Map1.esm", "TR1" );
            TR1.Load();
			EsmFile TR2 = new EsmFile( @"C:\Downloads\Code\Data\TR_Map2.esm", "TR2" );
            TR2.Load();
			EsmFile Morrowind = new EsmFile( @"C:\Downloads\Code\Data\MW.esm", "Morrowind" );
			Morrowind.Load();
			Morrowind.Records.AddRange( TRdata.Records );
			Morrowind.Records.AddRange( TR1.Records );
			Morrowind.Records.AddRange( TR2.Records );
			ListKeyTargets( Morrowind );
        }
    }
}
