﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using MWDataGrabber.SubRecords;

namespace MWDataGrabber.Records
{
    public class Cont : Record
    {
		private bool _organic;
		private List<SubRecords.ContainerItem> _contents = new List<ContainerItem>();
        private float _weight;

		public Cont( BinaryReader source )
            : base( source )
        {
			_type = RecordType.Cont;
        }

        protected override void ProcessSubRecord( string id, int length )
        {
            switch ( id )
            {
                case "CNDT":
                    _weight = ReadFloat();
                    break;
				case "FLAG":
					int tmp = ReadInt();
					_organic = ( ( tmp & 1 ) == 1 );
					break;
				case "NPCO":
					_contents.Add( new SubRecords.ContainerItem( ReadInt(), ReadString( length - 4 ) ) );
					break;
                default:
                    base.ProcessSubRecord( id, length );
                    break;
            }
        }

		public bool Organic
		{
			get
			{
				return _organic;
			}
		}

		public float Weight
		{
			get
			{
				return _weight;
			}
		}

		public List<ContainerItem> Contents
		{
			get
			{
				return _contents;
			}
		}
    }
}
