using System.Globalization;

namespace MWDataGrabber.SubRecords
{
    public class Door : CellObject
    {
        private float _doorX;
        private float _doorY;
        private float _doorZ;
        private float _doorRotationX;
        private float _doorRotationY;
        private float _doorRotationZ;
        private string _doorName;

        public Door( int id )
            : base( id )
        {
        }

        public static Door DoorFromObject( CellObject obj )
        {
            Door d = new Door( obj._id );
            d.X = obj.X;
            d.Y = obj.Y;
            d.Z = obj.Z;
            d.XRotation = obj.XRotation;
            d.YRotation = obj.YRotation;
            d.ZRotation = obj.ZRotation;
            return d;
        }

        public float DoorX
        {
            get { return _doorX; }
            set { _doorX = value; }
        }

        public float DoorY
        {
            get { return _doorY; }
            set { _doorZ = value; }
        }

        public float DoorZ
        {
            get { return _doorZ; }
            set { _doorY = value; }
        }

        public float DoorRotationX
        {
            get { return _doorRotationX; }
            set { _doorRotationX = value; }
        }

        public float DoorRotationY
        {
            get { return _doorRotationY; }
            set { _doorRotationY = value; }
        }

        public float DoorRotationZ
        {
            get { return _doorRotationZ; }
            set { _doorRotationZ = value; }
        }

        public string DoorName
        {
            get { return _doorName; }
            set { _doorName = value; }
        }

        public override string ToString()
        {
            return string.Format( CultureInfo.InvariantCulture, "{0:0.000}\t{1:0.000}\t{2:0.000}", _x, _y, _z );
        }

    }
}
